/* 
 THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 EITHER EXPRESSED OR IMPLIED,  INCLUDING BUT NOT LIMITED TO THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.

 This code is free for both personal and commercial use, but you are
 expressly forbidden from selling.

 **************************************************************************

 PROJECT NAME:
   Adobe CS3 Install generator

 FILE NAME:
   AdobeCS3.js

 DESCRIPTION:
   
 COPYRIGHT:
   Copyright (c) Zoltn Gmri 2007.
   All rights reserved.
   
 NOTES:
   The original version of this source code and the article that
   includes this source code can be found at:
     http://www.gomori.hu

 CREATED:
   2007.12.14
   
 LAST MODIFIED:
   2007.12.19
   
 VERSION:
   v1.0 Build 2
   
TO DO:

 **************************************************************************
*/

var TEMPLATE_SOURCE = "C:\\AdobeCS3\\Template";
var TARGET = "C:\\AdobeCS3\\Target";
var INSTALL_SOURCE = "\\\\server\\INST\\Adobe CS3 Design Standard HU";
var SOURCE = "D:\\Adobe CS3";
var MSITools = "C:\\Program Files\\Microsoft Platform SDK for Windows Server 2003 R2\\Bin";


var ForAppending = 8;
var i;

var FSO = new ActiveXObject("Scripting.FileSystemObject");
var WshShell = new ActiveXObject("WScript.Shell");

// Create dir TARGET\Deployment
FSO.CreateFolder(TARGET + "\\deployment");
// Create dir TARGET\payloads\AdobeDesignSuiteStandardhu_HU_Volume
FSO.CreateFolder(TARGET + "\\payloads");
FSO.CreateFolder(TARGET + "\\payloads\\AdobeDesignSuiteStandardhu_HU_Volume");
// Copy TEMPLATE_SOURCE\application.xml.override TARGET\payloads\AdobeDesignSuiteStandardhu_HU_Volume
FSO.CopyFile(TEMPLATE_SOURCE + "\\application.xml.override", TARGET + "\\payloads\\AdobeDesignSuiteStandardhu_HU_Volume\\application.xml.override");
// Generate templates from TEMPLATE_SOURCE to TARGET\Deployment
var Env = WshShell.Environment("PROCESS");
Env("SOURCE_PATH") = INSTALL_SOURCE;

var XmlName, src, buff, dst;
var XmlFiles = FSO.GetFolder(TEMPLATE_SOURCE);
XmlEnum = new Enumerator(XmlFiles.files);
for (; !XmlEnum.atEnd(); XmlEnum.moveNext())
{
    XmlName = XmlEnum.item().Name;
    if(XmlName.substr(XmlName.length-4,4).toLowerCase() == ".xml")
    {
        src = FSO.OpenTextFile(TEMPLATE_SOURCE + "\\" + XmlName);
        buff = src.ReadAll();
        src.Close();
        buff = WshShell.ExpandEnvironmentStrings(buff);
        dst = FSO.CreateTextFile(TARGET + "\\deployment\\" + XmlName);
        dst.Write(buff);
        dst.Close();
    }
}

// Generate MST files
var PropertyArr;
PropertyArr = new Array();

// WinMediaBootstrapper.mst
PropertyArr[0] = CreateProperty("ADOBE_SETUP","1");
PropertyArr[1] = CreateProperty("MSIRESTARTMANAGERCONTROL","Disable");
PropertyArr[2] = CreateProperty("PROPERTY_FILE",INSTALL_SOURCE + "\\deployment\\WinMediaBootstrapper.xml");
CreateMST(SOURCE + "\\WinMediaBootstrapper.msi",TARGET + "\\deployment\\WinMediaBootstrapper.mst",PropertyArr);

// Suite MSTs
var MSIFileNames = new Array(
    "AdobeAssetServices3All",
    "AdobeCMapsAll",
    "AdobeCameraRaw4.0All",
    "AdobePDFL8All",
    "AdobeTypeSupportAll",
    "AdobeAUM5.1All",
    "AdobeALMAnchorServiceAll",
    "AdobeBridge2All",
    "BridgeStartMeeting",
    "AdobeColorCommonSetAll",
    "AdobeColorEU_RecommendedAll",
    "AdobeColorJA_ExtraSettingsAll",
    "AdobeColorNA_ExtraSettingsAll",
    "AdobeDefaultLanguageCS3All",
    "AdobeExtendScriptToolKitAll",
    "AdobeFontsAll",
    "AdobeHelpViewerAll",
    "AdobeLinguisticsAll",
    "AdobeStockPhotos1.5All",
    "AdobeVersionCueClient3All",
    "AdobeWinSoftLinguisticsPluginAll",
    "AdobeXMPPanelsAll",
    "AdobePDFSettingsAll",
    "AdobeDeviceCentralAll",
    "AdobeColorPhotoshopAll",
    "AdobeInDesignCS3IconHandler",
    "AdobeSINGAll",
    "AHVSTIAll",
    "AdobeBridgeTalkPluginAll",
    "AdobeMotionPictureAll",
    "AdobeWASAll",
    "AdobeVersionCue3All",
    "AdobeIllustrator13hu_HU",
    "AdobeInDesign5cs_CZ",
    "AdobePhotoshop10hu_HU",
    "AdobeDesignSuiteStandardhu_HU_Volume");

for(i=0;i<MSIFileNames.length;i++)
{
    PropertyArr[2].Value = INSTALL_SOURCE + "\\deployment\\" + MSIFileNames[i] + ".xml";
    CreateMST(SOURCE + "\\payloads\\" + MSIFileNames[i] + "\\" + MSIFileNames[i] + ".msi", TARGET + "\\deployment\\" + MSIFileNames[i] + ".mst", PropertyArr);
}

function CreateMST(MSIName, MSTName, PropertyArr)
{
    var i, PropFile;
    var WshShell = new ActiveXObject("WScript.Shell");
    var FSO = new ActiveXObject("Scripting.FileSystemObject");
    var MSINameCopy = WshShell.ExpandEnvironmentStrings("%TEMP%") + "\\Temp.msi";
    var MSITableDir = WshShell.ExpandEnvironmentStrings("%TEMP%") + "\\MSITables";
    FSO.CreateFolder(MSITableDir);
    // Copy MSI to %TEMP%
    FSO.CopyFile(MSIName, WshShell.ExpandEnvironmentStrings("%TEMP%") + "\\Temp.msi");
    // Export Property Table
    ExecWait("\"" + MSITools + "\\MsiDb.Exe\" -e -d \"" + MSINameCopy + "\" -f \"" + MSITableDir + "\" Property");
    // Add PropertyArr to Property Table
    PropFile = FSO.OpenTextFile(MSITableDir + "\\Property.idt",ForAppending);
    for(i = 0; i < PropertyArr.length; i++)
        PropFile.WriteLine(PropertyArr[i].Property + "\t" + PropertyArr[i].Value);
    PropFile.Close();
    // Import Property Table to MSI
    ExecWait("\"" + MSITools + "\\MsiDb.Exe\" -i -d \"" + MSINameCopy + "\" -f \"" + MSITableDir + "\" Property");
    // Create MST
    ExecWait("\"" + MSITools + "\\MsiTran.Exe\" -g \"" + MSIName + "\" \"" + MSINameCopy + "\" \"" + MSTName + "\"");
    // Delete %TEMP% files
    FSO.DeleteFile(MSINameCopy);
    FSO.DeleteFolder(MSITableDir);
}
function ExecWait(cmdline)
{
    var WshShell = new ActiveXObject("WScript.Shell");
    var execobj;
    execobj = WshShell.Exec(cmdline);
    while(execobj.Status == 0)
        WScript.Sleep(100);
    return execobj;
}
function CreateProperty(Property, Value)
{
    var retvalue = new Object();
    retvalue.Property = Property;
    retvalue.Value = Value;
    return retvalue;
}
